define(
   [
      'codemirror/lib/codemirror',
      'codemirror/addon/mode/simple',
   ],
   function(CodeMirror, Simple) {

      var onload = function() {
         $.ajaxSetup({ cache: true });
         $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/jquery.jqplot.js").done(function() {
            $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/jqplot.cursor.js");
            $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/jqplot.highlighter.js");
            $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/jqplot.logAxisRenderer.js");
            $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/jqplot.enhancedLegendRenderer.js");
         });

         var cssNode = document.createElement('link');
         cssNode.type = 'text/css';
         cssNode.rel = 'stylesheet';
         cssNode.href = Jupyter.notebook.base_url + 'kernelspecs/biocham/jquery.jqplot.min.css';
         document.head.appendChild(cssNode);

         $('#kernel_logo_widget').wrap(function() {
            var link = $('<a/>');
            link.attr('href', 'http://lifeware.inria.fr/biocham4/doc/');
            link.attr('target', '_blank');
            link.attr('title', 'Biocham Manual');
            link.text($(this).text());
            return link;
         });
      }

      $.getScript(Jupyter.notebook.base_url + "kernelspecs/biocham/commands.js").done(function() {
         CodeMirror.defineSimpleMode("biocham", {
            // The start state contains the rules that are intially used
            start: [
               // The regex matches the token, the token property contains the type
               {regex: /"(?:[^\\]|\\.)*?(?:"|$)/, token: "string"},
               // Rules are matched in the order in which they appear
               {regex: commands, token: "keyword"},
               {regex: /integral/, token: "keyword"},
               {regex: /@|::|[-+\/*=<>!]+/, token: "operator"},
               {regex: /'(?:[^\\]|\\.)*?'/, token: "atom"},
               {regex: /[a-zA-Z][\w]*:\s/, token: "attribute"},
               {regex: /[a-zA-Z][\w]*/, token: "variable"},
               {regex: /0x[a-f\d]+|[-+]?\b(?:\.\d+|\d+\.?\d*)(?:e[-+]?\d+)?/i,
                  token: "string-2"},
               {regex: /%.*/, token: "comment"},
               // indent and dedent properties guide autoindentation
               {regex: /[\{\[\(]/, indent: true},
               {regex: /[\}\]\)]/, dedent: true},
            ],
            // The meta property contains global information about the mode. It
            // can contain properties like lineComment, which are supported by
            // all modes, and also directives like dontIndentStates, which are
            // specific to simple modes.
            meta: {
               dontIndentStates: ["comment"],
               lineComment: "%"
            }
         });
      });

      return {onload: onload}
});
